<?php
/**
  * M2F Admin.
  *
  * @author Patricio Anguita
  * @license http://opensource.org/licenses/gpl-license.php GNU Public License
  * @version $Revision: 1.69 $
  * @internal $Id: admin_m2f.php,v 1.69 2006/07/18 23:42:32 georgeocrawford Exp $
*/

define('IN_PHPBB', true);

if( !empty($setmodules) )
{
	$filename = basename(__FILE__);
	$module['Mail2Forum']['Settings'] = $filename . '?mode=settings';
	$module['Mail2Forum']['Mailing Lists'] = $filename . '?mode=mailinglists';
	$module['Mail2Forum']['Distribution Lists'] = $filename . '?mode=distributionlists';
	$module['Mail2Forum']['Log'] = $filename . '?mode=log';
	$module['Mail2Forum']['Patterns: Strip or Replace'] = $filename . '?mode=pattern_matching';
	$module['Mail2Forum']['Patterns: Block'] = $filename . '?mode=pattern_matching_block';
	$module['Mail2Forum']['Force Import'] = $filename . '?mode=force_import';
	$module['Mail2Forum']['Moderation'] = $filename . '?mode=moderate';
	
	//pnpphbb specifics by ksg-serg
	$phpbb_module['Mail2Forum'] = $module['Mail2Forum'];
	
	return;
}

// Include phpBB functions
$phpbb_root_path = './../';

require($phpbb_root_path . 'extension.inc');
require('pagestart.' . $phpEx);
include($phpbb_root_path . 'includes/functions_admin.'.$phpEx);


// pnphpbb specifics by ksg-serg
if(isset($ModName)) 
{
  $phpbb_root_path = './modules/' . $ModName . '/';
}

define('M2F_ROOT_PATH', $phpbb_root_path . 'm2f/');
	
foreach ($_POST as $k => $v)
{
	if (is_string($v)) $_POST[$k] = trim($v);
}

// Include M2F functions
require_once(M2F_ROOT_PATH. 'm2f_admin.php');

// Get current mode
$mode = (isset($_POST['mode']) || isset($_GET['mode'])) ? ( isset($_POST['mode'])  ? $_POST['mode'] : $_GET['mode']) : '';

// Depending on what we need to do...
switch ($mode) {
	
	case 'force_import':
		include_once($phpbb_root_path . 'extension.inc');
		include_once($phpbb_root_path . 'common.'.$phpEx);
		
		if ( !defined('IN_PHPBB') )
		{
			die('Hacking attempt');
		}
		
		include_once($phpbb_root_path . 'includes/bbcode.'.$phpEx);
		include_once($phpbb_root_path . 'includes/functions_post.'.$phpEx);
		include_once($phpbb_root_path . 'includes/functions_search.'.$phpEx);

		$message = force_import();
		
		$message .= '<form action="';
		$message .= append_sid('admin_m2f.' . $phpEx);
		$message .= '" method="POST"><input type="hidden" name="mode" value="force_import"><input type="submit" name="force_import" value="Force Import Again"></form><br /><br /><br />';

		message_die(GENERAL_MESSAGE, $message);

		break;
  	
  	
  	
	case 'email_subscriptions':
  
		$_POST['mailinglist_id'] = isset($_GET['mailinglist_id']) ? $_GET['mailinglist_id'] : $_POST['mailinglist_id'];
		$_POST['start'] = isset($_GET['start']) ? $_GET['start'] : $_POST['start'];

		if (@$_POST['action'])
		{
			$error = do_subscriptions_action($_POST['action']);
		}
		
		list($unsubscribed_groups, $subscribed_groups, $num_subscriptions, $is_board_subscribed, $ml_name) = get_subscriptions_info($_POST['mailinglist_id']);

		$template->set_filenames(array(
				'body' => 'admin/m2f_email_subscriptions.tpl')
		);
		
		if ($error)
		{
			$template->assign_block_vars('switch_alert', array('message' => '<span style="color:red">' . $error . '</span>'));
		}
		
		$template->assign_vars(array(
			'mailinglist_id' => $_POST['mailinglist_id'],
			'ml_name' => $ml_name,
			'U_SEARCH_USER' => append_sid("./../search.$phpEx?mode=searchuser"), 
			'L_FIND_USERNAME' => $lang['Find_username']
		));
		
		
		$subscriptions = get_email_subscriptions_info($_POST['mailinglist_id']);
		
		$results_per_page = 20;
		$start = $_POST['start'] ? $_POST['start'] : 0;
		
		if(count($subscriptions) != 0) 
		{
			if (count($subscriptions) == $start) $start = $start - $results_per_page;
			
			$template->assign_block_vars('switch_subscriptions', array());
			$template->assign_vars(array(
				'start' => $start
			));
				
			for ($i=$start; $i<$start+$results_per_page; $i++)
			{
				if (@$subscriptions[$i]) $template->assign_block_vars('switch_subscriptions.subscriptions', array('username' => $subscriptions[$i]['username'], 'user_id' => $subscriptions[$i]['user_id']));
			}
		} 
		else
		{
			$template->assign_vars(array(
				'start' => $start
			));
		}
		
		if(count($subscriptions) > $results_per_page) 
		{
			$pagination = generate_pagination("admin_m2f.$phpEx?mode=email_subscriptions&ml_name=$ml_name&mailinglist_id=$_POST[mailinglist_id]", count($subscriptions), $results_per_page, $start);
			$template->assign_block_vars('switch_pagination', array(
				'pagination' => $pagination, 
			));
		}

  break;
  
  // ---------------------------------------------------------------------------------
  
 	case 'subscriptions':

  	if (isset($_GET['mailinglist_id'])) $_POST['mailinglist_id'] = $_GET['mailinglist_id'];
  	
		if (@$_POST['action'])
		{
			do_subscriptions_action($_POST['action']);
		}
  	
		$template->set_filenames(array(
			'body' => 'admin/m2f_subscriptions.tpl')
			);
		
		list($unsubscribed_groups, $subscribed_groups, $num_subscriptions, $is_board_subscribed, $ml_name) = get_subscriptions_info($_POST['mailinglist_id']);

		// if there are some possible groups to subscribe to, display them:
		if (!empty($unsubscribed_groups))
		{
			$template->assign_block_vars('switch_subscribe_group', array());
			$template->assign_vars(array(
				'S_GROUP_SELECT' => $unsubscribed_groups
			));
		}

		// display currently subscribed groups
		if (!empty($subscribed_groups))
		{
		  $template->assign_block_vars('switch_subscribed_groups', array());
			foreach ($subscribed_groups as $group)
			{
				$template->assign_block_vars('switch_subscribed_groups.subscribed_groups', array(
				'group_id' => $group['group_id'],
				'group_name' => $group['group_name']
				));
			}
		}

		(intval($is_board_subscribed) == 1) ? $template->assign_block_vars('switch_unsubscribe_board', array()) : $template->assign_block_vars('switch_subscribe_board', array());
		
		$template->assign_vars(array(
      'S_M2F_ACTION' => append_sid('admin_m2f.' . $phpEx),
			'start' => '0',
			'mailinglist_id' => $_POST['mailinglist_id'],
			'num_subscriptions' => $num_subscriptions,
     	'ml_name' => $ml_name	
		));
  
  break;
  
  // ---------------------------------------------------------------------------------

	case 'mailinglists':
  
		if ((@$_POST['action'] == 'Edit') && (!isset($_POST['edited'])))
		{
			$mailinglists = get_mailinglists();
			
			$template->set_filenames(array(
				'body' => 'admin/m2f_edit_mailinglist.tpl')
			);
	
			$template->assign_vars(array(
						'S_M2F_ACTION' => append_sid('admin_m2f.' . $phpEx),
						'list_email' => $mailinglists[$_POST['mailinglist_id']]['list_email'],
						'mailinglist_id' => $_POST['mailinglist_id'],
						'ml_name' => $mailinglists[$_POST['mailinglist_id']]['name']
						));
												
			// Output the template
			$template->pparse('body');
			include('page_footer_admin.'.$phpEx);
			die;
		}

		if (@$_POST['action'])
		{
			do_mailinglist_action($_POST['action']);
		}
		
		$template->set_filenames(array(
			'body' => 'admin/m2f_mailinglists.tpl')
			);

		if (@$_POST['action'] == 'Add' && (empty($_POST['ml_name']) || empty($_POST['list_email'])) )
		{
			$template->assign_block_vars('switch_add_list_error', array());
			$template->assign_vars(array(
			'ml_name' => $_POST['ml_name'],
			'list_email' => $_POST['list_email'],
			));
		}
		
		$mailinglists = get_mailinglists();
			
		if (count($mailinglists) != 0) 
		{
			$template->assign_block_vars('switch_mailinglists', array());

		  foreach ($mailinglists as $mailinglist_id => $mailinglist_details)
		  {
		    $template->assign_block_vars('switch_mailinglists.mailinglists', array(
		    'mailinglist_id' => $mailinglist_id,
		    'num_subscriptions' => $mailinglist_details['num_subscriptions'],
		    'num_group_subscriptions' => $mailinglist_details['num_group_subscriptions'],
		    'board_subscribed' => ($mailinglist_details['board_subscribed'] == 1) ? '<span style="color:#FFA34F">Yes</span>' : 'No',
		    'name' => $mailinglist_details['name'],
		    'list_email' => $mailinglist_details['list_email'],
		    'status' => $mailinglist_details['status'],
		    'action' => ( $mailinglist_details['status']==0 ? 'Activate' : 'Deactivate')
			  ));
	  	}
		}
		
	break;

  // ---------------------------------------------------------------------------------

	case 'distributionlists':
	case 'default_distribution':
    if ((@$_POST['action'] == 'Configure') || isset($_GET['Configure']) || ($mode == 'default_distribution'))
		{
			if (isset($_GET['distributionlist_id'])) $_POST['distributionlist_id'] = $_GET['distributionlist_id'];
			$distributionlist_id = ($mode == 'default_distribution') ? 0 : $_POST['distributionlist_id'];

			if (isset($_POST['linkable_patterns']))
			{
				foreach ($_POST['linkable_patterns'] as $pattern_id)
				{
					link_pattern($pattern_id, $distributionlist_id);
				}
			}
			
			if (isset($_POST['save_settings']) || isset($_POST['test_sendmail']) || isset($_POST['test_gmail']) || isset($_POST['test_smtp']) || isset($_POST['link_patterns']) || isset($_POST['test_mbox']) || isset($_POST['test_pop']))
			{
				configure_dist_list();
	
				if (isset($_POST['save_settings']))
				{
					$message = 'Your ' . ($mode == 'default_distribution' ? 'default ' : '') . 'distribution list settings have been saved.' . "<br /><br />" . sprintf('Click %shere%s to return to Distribution Lists' , "<a href=\"" . append_sid("admin_m2f.$phpEx?mode=distributionlists") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");
					message_die(GENERAL_MESSAGE, $message);
				}
			}
			
			$template->set_filenames(array(
					'body' => 'admin/m2f_distributionlist_settings.tpl')
			);
			
			// Get configs
			$params = get_dist_list_settings();
			$template->assign_vars($params);
			
			if (isset($_POST['test_smtp']))
			{
				list($smtp_success, $smtp_results) = test_smtp();
				$template->assign_block_vars('switch_alert', array('header' => 'SMTP connect results', 'message' => $smtp_success ? '<span style="color: green">' . $smtp_results . '</span>' : '<span style="color: red">' . $smtp_results . '</span>'));
			}
			if (isset($_POST['test_gmail']))
			{
				list($gmail_success, $gmail_results) = test_gmail();
				$template->assign_block_vars('switch_alert', array('header' => 'gMail connect results', 'message' => $gmail_success ? '<span style="color: green">' . $gmail_results . '</span>' : '<span style="color: red">' . $gmail_results . '</span>'));
			}
			if (isset($_POST['test_mbox']))
			{
				list($mbox_success, $mbox_results) = test_mbox();
				$template->assign_block_vars('switch_alert', array('header' => 'Mbox path test results', 'message' => $mbox_success ? '<span style="color: green">' . $mbox_results . '</span>' : '<span style="color: red">' . $mbox_results . '</span>'));
			}
			if (isset($_POST['test_pop']))
			{
				list($pop_success, $pop_results) = test_pop();
				$template->assign_block_vars('switch_alert', array('header' => 'POP connect results', 'message' => $pop_success ? '<span style="color: green">' . $pop_results . '</span>' : '<span style="color: red">' . $pop_results . '</span>'));
			}
			if (isset($_POST['test_sendmail']))
			{
				$sendmail_success = test_sendmail();
				$template->assign_block_vars('switch_alert', array('header' => 'Sendmail path', 'message' => $sendmail_success ? '<span style="color: green">Sendmail path OK</p>' : '<span style="color: red">ERROR: Sendmail path was incorrect. Please correct this on the <a href="' . append_sid('admin_m2f.' . $phpEx) . '&mode=settings" target="main">Settings page</a></p>'));
			}
			
			//Pattern Matching
			if (isset($_GET['move_pattern']))
			{
				switch ($_GET['move_pattern'])
				{
					case 'up':
						move_pattern_up($_GET['distributionlist_id'], $_GET['pattern_id']);
						break;
					case 'down':
						move_pattern_down($_GET['distributionlist_id'], $_GET['pattern_id']);
						break;
					case 'remove':
						remove_pattern_link($_GET['distributionlist_id'], $_GET['pattern_id']);
						break;
				}
			}

			$template->assign_vars(array(
			'search_patterns_link' => append_sid('admin_m2f.php?mode=pattern_matching'),
			'block_patterns_link' => append_sid('admin_m2f.php?mode=pattern_matching_block'),
			));
			$patterns = array('search' => array('linked' => get_linked_patterns($distributionlist_id, 'search'), 
																			 			'unlinked' => get_unlinked_patterns($distributionlist_id, 'search')
																				), 
												'block' => array('linked' => get_linked_patterns($distributionlist_id, 'block'), 
																						'unlinked' => get_unlinked_patterns($distributionlist_id, 'block')
																				));
																				
			foreach ($patterns as $purpose => $pattern_array)
			{
				if (count($pattern_array['linked']))
				{
					$template->assign_block_vars('switch_linked_' . $purpose . '_patterns', array());
					$num_patterns = count($pattern_array['linked']) - 1;
					foreach ($pattern_array['linked'] as $key => $pattern)
					{
						$move_up_link = ($key == 0) ? '&nbsp;&nbsp;&nbsp;' : '<a href="' . append_sid('admin_m2f.' . $phpEx) . '&Configure=1&distributionlist_id=' . $pattern['distributionlist_id'] . '&mode=' . $mode . '&pattern_id=' . $pattern['pattern_id'] . '&move_pattern=up">up</a><b>&#8593;</b>';
						$move_down_link = ($key == $num_patterns) ? '&nbsp;&nbsp;&nbsp;' : '<a href="' . append_sid('admin_m2f.' . $phpEx) . '&Configure=1&distributionlist_id=' . $pattern['distributionlist_id'] . '&mode=' . $mode . '&pattern_id=' . $pattern['pattern_id'] . '&move_pattern=down">down</a><b>&#8595;</b>';
						$remove_link = '<a href="' . append_sid('admin_m2f.' . $phpEx) . '&Configure=1&distributionlist_id=' . $pattern['distributionlist_id'] . '&mode=' . $mode . '&pattern_id=' . $pattern['pattern_id'] . '&move_pattern=remove">Remove</a>';
						$targets = array();
						if (_M2F_TARGET_SUBJECT_ & $pattern['target']) $targets[] = 'subject';
						if (_M2F_TARGET_BODY_ & $pattern['target']) $targets[] = 'body';
						if (_M2F_TARGET_HEADERS_ & $pattern['target']) $targets[] = 'headers';
						$target = implode(', ', $targets);
						
						$template->assign_block_vars('switch_linked_' . $purpose . '_patterns.patterns', array(
							'description' => htmlentities($pattern['description']),
							'move_up_link' => $move_up_link,
							'move_down_link' => $move_down_link,
							'remove_link' => $remove_link,
							'target' => $target,
							));
					}
				}
				if (count($pattern_array['unlinked']))
				{
					$template->assign_block_vars('switch_unlinked_' . $purpose . '_patterns', array());
					foreach ($pattern_array['unlinked'] as $key => $pattern)
					{
						$targets = array();
						if (_M2F_TARGET_SUBJECT_ & $pattern['target']) $targets[] = 'subject';
						if (_M2F_TARGET_BODY_ & $pattern['target']) $targets[] = 'body';
						if (_M2F_TARGET_HEADERS_ & $pattern['target']) $targets[] = 'headers';
						$target = implode(', ', $targets);

						$template->assign_block_vars('switch_unlinked_' . $purpose . '_patterns.patterns', array(
							'id' => $pattern['pattern_id'],
							'description' => ($key + 1) . '. (' . $target . ') - ' . htmlentities(strlen($pattern['description']) > 120 ? substr($pattern['description'], 0, 120) . '...' : $pattern['description'])
							));
					}
				}
			}
		} 
    
    // -------------------------------------
    // Distribution Lists overview page
    else 
		{
			$mailinglists = get_mailinglists();
	  	if (count($mailinglists) == 0) {
        $message = sprintf('You must create a mailing list before you can set up a distribution.<br><br> Click %shere%s to go the the Mailing Lists page' , "<a href=\"" . append_sid("admin_m2f.$phpEx?mode=mailinglists") . "\">", "</a>");
	   		message_die(GENERAL_MESSAGE, $message);
	  	}

      $template->set_filenames(array(
      		'body' => 'admin/m2f_distributionlists.tpl')
      );
      
			if (@$_POST['action'])
			{
				do_dist_lists_action($_POST['action']);
			}

			// Find as yet unlinked forums and mailinglists
			$unlinked_forums = get_forums();
      $unlinked_mailinglists = get_unlinked_mailinglists();
      
  		if ((count($unlinked_forums) != 0) && (count($unlinked_mailinglists) != 0))
  		{
  			$template->assign_block_vars('switch_possible_combos', array());
				  
				if($unlinked_forums)
				{						
					foreach ($unlinked_forums as $forum_details)
					{
					  $template->assign_block_vars('switch_possible_combos.forums', array(
						'forum_id' => $forum_details['forum_id'],
				  	'forum_name' => $forum_details['forum_name']
						 ));
					}
				}
				
				if($unlinked_mailinglists)
				{
					foreach ($unlinked_mailinglists as $mailinglist_details)
				  {
				    $template->assign_block_vars('switch_possible_combos.mailinglists', array(
				    'mailinglist_id' => $mailinglist_details['mailinglist_id'],
				    'list_email' => $mailinglist_details['list_email'],
				    'name' => $mailinglist_details['name'],
			    ));
				  }
				}
			}
			else
			{
  			$template->assign_block_vars('switch_no_possible_combos', array());
			}
			
			// Setup distributionlist vars
			$distributionlists = get_dist_lists();
			
			if (count($distributionlists) != 0) 
			{
				$template->assign_block_vars('switch_distributionlists', array());

			  foreach ($distributionlists as $distributionlist_id => $distributionlist_details)
			  {
			  	$template->assign_block_vars('switch_distributionlists.distributionlists', $distributionlist_details);
			  }
			}
    }    
    
  break;
  

  // ---------------------------------------------------------------------------------
	case 'log':
    
		switch (_M2F_LOG_METHOD_)
		{
			case 'FILE':
				if (isset($_POST['erase_log']))
				{
					erase_file_log();
					$message = 'The Mail2Forum log file was successfully erased.' . "<br /><br />" . sprintf('Click %shere%s to return to Mail 2 Forum Log' , "<a href=\"" . append_sid("admin_m2f.$phpEx?mode=log") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");
					message_die(GENERAL_MESSAGE, $message);
				}
				if (isset($_GET['iframe']))
				{
					$log_file = get_log_file();
					$template->set_filenames(array(
						'body' => 'admin/m2f_tools_iframe.tpl')
					);
					
					$template->assign_block_vars('switch_view_log_file', array());
					
					$template->assign_vars(array(
						'log_file' => $log_file
						));
					
					$template->pparse('body');
					echo '</body></html>';
					die;
				}
				else
				{
					$template->set_filenames(array(
						'body' => 'admin/m2f_tools.tpl')
					);
					
					$template->assign_block_vars('switch_view_log', array());
					
					$url = 'admin_m2f.php?mode=log&iframe=1';
					
					$template->assign_block_vars('switch_file_log', array());
					
					if (isset($_POST['view_complete_log'])) $url .= '&view_complete_log=1';
					
					$template->assign_vars(array(
						'_M2F_IFRAME_URL_' => append_sid($url)
						));
				}
				
				break;
				
			case 'DATABASE':
			default:
				if (isset($_POST['erase_log']))
				{
					erase_db_log();
					$message = 'The Mail2Forum database log was successfully erased.' . "<br /><br />" . sprintf('Click %shere%s to return to Mail 2 Forum Log' , "<a href=\"" . append_sid("admin_m2f.$phpEx?mode=log") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");
					message_die(GENERAL_MESSAGE, $message);
				}
				else if (isset($_GET['iframe']))
				{
					$log_levels = array('emergency', 'alert', 'critical', 'error', 'warning', 'notice', 'info', 'debug');
					$db_result = get_db_log();
	
					$template->set_filenames(array(
						'body' => 'admin/m2f_tools_iframe.tpl')
					);
					
					if (count($db_result) > 0)
					{
						$template->assign_block_vars('switch_view_log_database', array());
						foreach ($db_result as $result_row)
						{
							$template->assign_block_vars('switch_view_log_database.database_line', array(
							'time' => $result_row['logtime'],
							'level' => $log_levels[($result_row['priority'])],
							'message' => htmlentities($result_row['message'])
							 ));
						}
						$template->pparse('body');
						echo '</body></html>';
					}
					else
					{
						$template->assign_block_vars('switch_nothing', array());
						$template->pparse('body');
						echo '</body></html>';
					}
					die;
				}
				else
				{
					$template->set_filenames(array(
						'body' => 'admin/m2f_tools.tpl')
					);
					
					$template->assign_block_vars('switch_view_log', array());
					
					$url = 'admin_m2f.php?mode=log&iframe=1';
					$url .= add_to_url();
	
					$template->assign_vars(array(
						'_M2F_IFRAME_URL_' => append_sid($url)
						));
						
					$template->assign_block_vars('switch_database_log', array());
					
					if (isset($_POST['view_log_period'])) $template->assign_vars(array('_M2F_LOG_DATE_FROM_' => date_from(), '_M2F_LOG_DATE_TO_' => date_to() ));
					else $template->assign_vars(array('_M2F_LOG_DATE_FROM_' => last_hour(), '_M2F_LOG_DATE_TO_' => this_hour() ));
				}
				break;
		}
	break;
  
  
  // ---------------------------------------------------------------------------------
	case 'pattern_matching':
	case 'pattern_matching_block':
	
		switch ($mode)
		{
			case 'pattern_matching':
				$template->set_filenames(array(
						'body' => 'admin/m2f_pattern_matching.tpl')
				);    
				break;
			case 'pattern_matching_block':
				$template->set_filenames(array(
						'body' => 'admin/m2f_pattern_matching_block.tpl')
				);    
				break;
    }
    				
		if (in_array(@$_POST['action'], array('Submit Edited Pattern', 'Save', 'Test Pattern', 'Add a new pattern')))
		{
			// do some error checks
			
			if ($_POST['match'] === '')
			{
				// error - blank search could cause problems!
				$template->assign_block_vars('switch_blank_search_string', array());
				break;
			}

			if (!is_array($_POST['target']))
			{
				// error - must specify target!
				$template->assign_block_vars('switch_no_target', array());
				break;
			}
			
			if ($_POST['use_regexp'] == 1)
			{
				// test for a valid pcre match string
				$pattern_match_array = test_pattern_match_string($_POST['match']);
				$pattern_match_error = $pattern_match_array[0];
				if ($pattern_match_error)
				{
					$template->assign_block_vars('switch_bad_search_pattern_edit', array(
						'match' => $_POST['match'],
						'errors' => implode('<br />', $pattern_match_array[1])
						));
					break;
				}
			}
			
			if (!empty($_POST['modifiers']) && $_POST['use_regexp'] == 1)
			{
				// test the modifiers to check they're valid. First just get the letters - [a-zA-Z] - then remove duplicates. What fun!
				preg_match_all('/(?:([a-zA-Z])|.)/', $_POST['modifiers'], $matches);
				$_POST['modifiers'] = implode('', array_unique($matches[1]));
				$pattern_modifiers_array = test_pattern_modifiers($_POST['modifiers']);
			
				if ($pattern_modifiers_array[1])
				{
					// the 'e' modifier was set - not allowed at the moment
					$template->assign_block_vars('switch_eval_modifier', array());
					break;
				}
				
				if (!empty($pattern_modifiers_array[0]))
				{
					// bad modifiers were found
					$template->assign_block_vars('switch_bad_modifiers', array(
						'modifiers' => implode(', ', $pattern_modifiers_array[0]),
					));
					break;
				}
			}
			
			if ($_POST['description'] == '')
			{
				$_POST['description'] = '(no description)';
			}
		}
		

		switch (@$_POST['action'])
		{
			case 'Edit':
				$patterns = get_patterns($_POST['id']);
				$pattern = $patterns[0];
				$template->assign_block_vars('switch_edit', array(
					'id' => $pattern['pattern_id'],
					'description' => $pattern['description'],
					'match' => $pattern['pattern_match'],
					'replace' => (($mode == 'pattern_matching') ? $pattern['pattern_replace'] : ''),
					'use_regexp' => ($pattern['use_regexp'] == 1 ? 'Checked' : ''),
					'modifiers' => $pattern['modifiers'],
					'target_subject' => (_M2F_TARGET_SUBJECT_ & $pattern['target'] ? 'Checked' : ''),
					'target_body' => (_M2F_TARGET_BODY_ & $pattern['target'] ? 'Checked' : ''),
					'target_headers' => (_M2F_TARGET_HEADERS_ & $pattern['target'] ? 'Checked' : ''),
						));
				break;

			case 'Test Pattern':
				update_pattern();
				$results = ($_POST['use_regexp'] == '1') ? test_pattern_sample_preg() : test_pattern_sample();
			case 'Test':
				$sample = isset($_POST['sample']) ? $_POST['sample'] : 'Insert your sample text here';
				$patterns = get_patterns($_POST['id']);
				$pattern = $patterns[0];
				$template->assign_block_vars('switch_test', array(
					'id' => $pattern['pattern_id'],
					'description' => $pattern['description'],
					'match' => $pattern['pattern_match'],
					'replace' => (($mode == 'pattern_matching') ? $pattern['pattern_replace'] : ''),
					'modifiers' => $pattern['modifiers'],
					'use_regexp' => ($pattern['use_regexp'] == 1 ? 'Checked' : ''),
					'target_subject' => (_M2F_TARGET_SUBJECT_ & $pattern['target'] ? 'Checked' : ''),
					'target_body' => (_M2F_TARGET_BODY_ & $pattern['target'] ? 'Checked' : ''),
					'target_headers' => (_M2F_TARGET_HEADERS_ & $pattern['target'] ? 'Checked' : ''),
					'sample' => $sample,
					'results' => $results
					));
				break;
			
			case 'Save':
			case 'Submit Edited Pattern':
				update_pattern();
				break;

			case 'Delete':
				delete_pattern();
				break;

			case 'Add a new pattern':
				add_pattern($mode);
				break;
		}
			
		if (!isset($_POST['action']) || in_array(@$_POST['action'], array('Submit Edited Pattern', 'Delete', 'Add a new pattern', 'Save')))
		{
			$template->assign_block_vars('switch_intro', array('dist_list_link' => append_sid('admin_m2f.php?mode=distributionlists')));

			$patterns = get_patterns(FALSE, $mode);
			if (count($patterns))
			{
				$template->assign_block_vars('switch_patterns', array());
				foreach ($patterns as $pattern)
				{
					$trimmed_match = (strlen($pattern['pattern_match']) > 120) ? (substr($pattern['pattern_match'], 0, 120) . "\n(trimmed)") : $pattern['pattern_match'];
					$pattern_replace = (strlen($pattern['pattern_replace']) > 120) ? (substr($pattern['pattern_replace'], 0, 120) . "\n(trimmed)") : $pattern['pattern_replace'];
					
					$targets = array();
					if (_M2F_TARGET_SUBJECT_ & $pattern['target']) $targets[] = 'subject';
					if (_M2F_TARGET_BODY_ & $pattern['target']) $targets[] = 'body';
					if (_M2F_TARGET_HEADERS_ & $pattern['target']) $targets[] = 'headers';
					$target = implode(', ', $targets);
					
					switch($pattern['internal'])
					{
						case '1':
							$template->assign_block_vars('switch_patterns.internal_patterns', array(
								'id' => $pattern['pattern_id'],
								'description' => $pattern['description'],
								'match' => nl2br(htmlspecialchars(chunk_split($trimmed_match, 30, "\n"))),
								'replace' => nl2br(htmlspecialchars(chunk_split($pattern_replace, 30, "\n"))),
								'use_regexp' => ($pattern['use_regexp'] == 1 ? 'Yes' : 'No'),
								'target' => $target,
								'modifiers' => $pattern['modifiers'],
								));
							break;

						case '0':
							$template->assign_block_vars('switch_patterns.patterns', array(
								'id' => $pattern['pattern_id'],
								'description' => $pattern['description'],
								'match' => nl2br(htmlspecialchars(chunk_split($trimmed_match, 30, "\n"))),
								'replace' => nl2br(htmlspecialchars(chunk_split($pattern_replace, 30, "\n"))),
								'use_regexp' => ($pattern['use_regexp'] == 1 ? 'Yes' : 'No'),
								'target' => $target,
								'modifiers' => $pattern['modifiers'],
								));
							break;
					}
				}
			}
		}
		
		
  	break;
	
	
  // ---------------------------------------------------------------------------------

	case 'moderate':
	
		global $attach_config, $lang;
		
		$template->set_filenames(array(
				'body' => 'admin/m2f_moderation.tpl')
		);    

		$start = $_POST['start'] ? $_POST['start'] : ($_GET['start'] ? $_GET['start'] : 0);
		$view = $_POST['view'] ? $_POST['view'] : ($_GET['view'] ? $_GET['view'] : 'summary');
		$direction = $_POST['direction'] ? $_POST['direction'] : ($_GET['direction'] ? $_GET['direction'] : NULL);
		$action = $_POST['action'] ? $_POST['action'] : ($_GET['action'] ? $_GET['action'] : NULL);
		$results_per_page = 15;
		
		if ($action)
		{
			include_once($phpbb_root_path . 'extension.inc');
			include_once($phpbb_root_path . 'common.'.$phpEx);
			if ( !defined('IN_PHPBB') ) die('Hacking attempt');
			include_once($phpbb_root_path . 'includes/bbcode.'.$phpEx);
			include_once($phpbb_root_path . 'includes/functions_post.'.$phpEx);
			include_once($phpbb_root_path . 'includes/functions_search.'.$phpEx);

			switch ($action)
			{
				case 'Authorize':
					
					if (empty($_POST['message_ids'])) break;
					$entered_posts = array();
					$authorised = 0;
					foreach ($_POST['message_ids'] as $message_id)
					{
						$message = get_moderated_messages($message_id);
						if($message = $message[0])
						{
							$message['forum_msg'] = unserialize(base64_decode($message['forum_msg']));
							$message['mail_msg'] = unserialize(base64_decode($message['mail_msg']));
							$message['userdata'] = unserialize(base64_decode($message['userdata']));
							
							switch ($direction)
							{
								case 'in':
									$message['forum_msg']->topic_id = $message['topic_id'];
									
									$m2f_handler->new_mail_event_proceed(
																	$message['forum_msg'], 
																	$message['forum_id'], 
																	$message['user_id'], 
																	$message['mail_msg'], 
																	$message['userdata'], 
																	$message['mailinglist_id'], 
																	$message['distributionlist_id'],
																	array(),
																	TRUE,
																	$message['post_id']
																);
																
									$entered_posts[] = $message['post_id'];	
									$authorised++;
									delete_moderated_message($message_id);
									break;
									
								case 'out':
									$recipient_list = unserialize(base64_decode($message['recipient_list']));
									$m2f_handler->new_post_event_proceed($message['mail_msg'], $recipient_list);
									$authorised++;
									delete_moderated_message($message_id);
									break;
							}
						}
					}

					if ($authorised)
					{
						switch ($direction)
						{
							case 'in':
								if ($authorised == 1)
								{
									$template->assign_block_vars('switch_alert', array('message' => 'The message was successfully posted to the forum: <a href="' . append_sid($phpbb_root_path."viewtopic.{$phpEx}?p={$entered_posts[0]}") . "#{$entered_posts[0]}\" target=\"_blank\">post #$entered_posts[0]</a>"));
								}
								else
								{
									$results = array();
									foreach ($entered_posts as $id)
									{
										$results[] = '<a href="' . append_sid($phpbb_root_path."viewtopic.{$phpEx}?p=$id") . "#$id\" target=\"_blank\">post #$id</a>";
									}
									$template->assign_block_vars('switch_alert', array('message' => 'The messages were successfully posted to the forum: ' . implode(', ', $results)));
								}
								break;
								
							case 'out':
								if ($authorised == 1)
								{
									$template->assign_block_vars('switch_alert', array('message' => 'The email was successfully sent to the mailing list'));
								}
								else
								{
									$template->assign_block_vars('switch_alert', array('message' => $authorised . ' emails were successfully sent to the mailing list'));
								}
								break;
						}
					}
					else
					{
						$template->assign_block_vars('switch_alert', array('message' => '<span style="color:red">Error - stored message not found in database</span>'));
					}
					break;
					
				case 'Change Topic':
					if (isset($_POST['new_topic_id']) && isset($_POST['serialized_message_ids']) && check_topic_id($_POST['new_topic_id']))
					{
						$message_ids = unserialize(base64_decode($_POST['serialized_message_ids']));
						foreach ($message_ids as $message_id)
						{
							change_topic_id($message_id, $_POST['new_topic_id']);
						}
						$template->assign_block_vars('switch_alert', array('message' => 'The topic was changed successfully.'));
					}
					else
					{
						if (empty($_POST['message_ids'])) 
						{
							unset($action);
							break;
						}
						if (isset($_POST['new_topic_id']) && isset($_POST['serialized_message_ids']) && !check_topic_id($_POST['new_topic_id']))
						{
							$template->assign_block_vars('switch_alert', array('message' => '<span style="color:red">Error - topic ' . $_POST['new_topic_id'] . ' doesn\'t exist!</span>'));
							$_POST['message_ids'] = unserialize(base64_decode($_POST['serialized_message_ids']));
						}
						$template->assign_block_vars('switch_change_topic', array(
							'serialized_message_ids' => base64_encode(serialize($_POST['message_ids'])),
							'start' => $start,
							'direction' => $direction,
							'view' => $view,
							'cancel' => append_sid("admin_m2f.$phpEx?mode=moderate&view=$view&direction=$direction&start=$start"),
						));
						
						$template->assign_block_vars('switch_messages_' . $direction, array());
						$template->assign_block_vars('switch_back_to_overview', array(
							'overview' => '<a href="' . append_sid("admin_m2f.$phpEx?mode=moderate&view=$view&direction=$direction&start=$start") . '">Back to ' . (($direction == 'in') ? 'incoming' : 'outgoing') . ' messages</a>', 
						));
						
						foreach ($_POST['message_ids'] as $message_id)
						{
							$stored_msgs = get_moderated_messages($message_id);
							display_moderated_message($stored_msgs[0], $direction, FALSE);
						}
					}
					break;
		
				case 'preview':
					$message = get_moderated_messages($_GET['message_id']);
					$message = $message[0];
					$forum_msg = unserialize(base64_decode($message['forum_msg']));
					$userdata = unserialize(base64_decode($message['userdata']));
					$mail_msg = unserialize(base64_decode($message['mail_msg']));

					switch($direction)
					{
						case 'in':
							$forum_msg->topic_id = $message['topic_id'];
		
							$forum_msg->body = addslashes($forum_msg->body);
							$bbcode_uid = make_bbcode_uid(); 
							$message = str_replace("\'", "'", prepare_message(trim($forum_msg->body), 0, 1, 1, $bbcode_uid)); 
							$message = ( $board_config['allow_bbcode'] ) ? bbencode_second_pass($message, $bbcode_uid) : preg_replace('/\:[0-9a-z\:]+\]/si', ']', $message);
							$message = make_clickable($message);
				
							if ( isset($orig_word) )
							{
								$post_subject = preg_replace($orig_word, $replacement_word, $post_subject);
								$message = preg_replace($orig_word, $replacement_word, $message);
							}
				
							if ( $board_config['allow_smilies'] )
							{
								$message = smilies_pass($message);
							}
				
							$message = str_replace("\n", '<br />', $message);
				
							$template->set_filenames(array(
								'preview' => 'admin/m2f_moderation_in_preview.tpl')
							);
				
							$mini_post_img = $images['icon_minipost'];
							$mini_post_alt = $lang['Post'];
				
							$template->assign_vars(array(
								'ROW_COLOR' => '#' . $theme['td_color1'], 
								'ROW_CLASS' => $theme['td_class1'], 
				
								'MINI_POST_IMG' => '../' . $mini_post_img, 
								'POSTER_NAME' => empty($userdata['username']) ? $lang['Guest'] : $userdata['username'],
								'POST_DATE' => create_date($board_config['default_dateformat'], $forum_msg->datetime, $board_config['board_timezone']), 
								'POST_SUBJECT' => $forum_msg->title, 
								'MESSAGE' => $message,
								'L_AUTHOR' => $lang['Author'],
								'L_POSTED' => $lang['Posted'],
								'L_POST_SUBJECT' => $lang['Post_subject'], 
								'L_TOPIC_REVIEW' => $lang['Topic_review'],
									
								'L_MINI_POST_ALT' => $mini_post_alt)
							);
							
							break;
						
						case 'out':
							preg_match('/<body.*?>(.*)<\/body>/is', $mail_msg->html_body, $matches);
							$html_body = $matches[1];
						
							$template->set_filenames(array(
								'preview' => 'admin/m2f_moderation_out_preview.tpl')
							);

							$template->assign_vars(array(
								'ROW_COLOR' => '#' . $theme['td_color1'], 
								'ROW_CLASS' => $theme['td_class1'], 
								'MESSAGE' => $html_body)
							);
							break;
					}
					
					$template->assign_var_from_handle('preview', 'preview');
					
					$stored_msgs = get_moderated_messages($_GET['message_id']);
					$template->assign_block_vars('switch_messages_' . $direction, array());
					$template->assign_block_vars('switch_messages_' . $direction . '.switch_yes_messages', array());
						$template->assign_block_vars('switch_back_to_overview', array(
							'overview' => '<a href="' . append_sid("admin_m2f.$phpEx?mode=moderate&view=$view&direction=$direction&start=$start") . '">Back to ' . (($direction == 'in') ? 'incoming' : 'outgoing') . ' messages</a>', 
						));
					display_moderated_message($stored_msgs[0], $direction);
					break;
		
				case 'Delete':
					if (empty($_POST['message_ids'])) break;
					
					foreach ($_POST['message_ids'] as $message_id)
					{
						$message = get_moderated_messages($message_id);
						delete_moderated_message($message_id, $message[0]['post_id']);
					}
					$num = count($_POST['message_ids']);
					if ($num > 1)
					{
						$template->assign_block_vars('switch_alert', array('message' => $num . ' messages were successfully deleted.'));
					}
					else
					{
						$template->assign_block_vars('switch_alert', array('message' => 'The message was successfully deleted.'));
					}
					break;
			}
		}

		if ( !(@$action == 'Change Topic' && (!isset($_POST['new_topic_id']) || (!check_topic_id($_POST['new_topic_id']) && isset($_POST['new_topic_id'])) ) ) && !(@$action == 'preview'))
		{
			list($num_in, $num_out) = count_moderated_messages();
			
			if ($view == 'summary') $results_per_page = 5;
			
			if (!($direction == 'out' && $view == 'list'))
			{
				if ($num_in)
				{
					$template->assign_block_vars('switch_messages_in', array(
						'start' => $start,
						'view' => $view,
					));
					
					if ($num_in == $start) $start = $start - $results_per_page;
					$stored_msgs = get_moderated_messages($start, $results_per_page, 'in');
		
					foreach ($stored_msgs as $message)
					{
						display_moderated_message($message, 'in');
					}
					
					$template->assign_block_vars('switch_messages_in.switch_yes_messages', array());
				}
				else
				{
					$template->assign_block_vars('switch_messages_in', array());
					$template->assign_block_vars('switch_messages_in.switch_no_messages', array());
				}
		
				if ($num_in > $results_per_page) 
				{
					if ($view == 'summary')
					{
						$template->assign_block_vars('switch_more_in', array(
							'more' => '<a href="' . append_sid('admin_m2f.php?mode=moderate&direction=in&view=list') . '">view all (' . $num_in . ')</a>', 
						));
					}
					else
					{
						$pagination = generate_pagination("admin_m2f.$phpEx?mode=moderate&direction=in&view=list", $num_in, $results_per_page, $start);
						$template->assign_block_vars('switch_messages_in.switch_pagination', array(
							'pagination' => $pagination, 
						));
					}
				}
			}
			
			if ($view == 'list')
			{
				$template->assign_block_vars('switch_back_to_overview', array(
					'overview' => '<a href="' . append_sid('admin_m2f.php?mode=moderate') . '">Back to moderation overview</a>', 
				));
			}
			else
			{
					$template->assign_block_vars('switch_spacer', array());
			}
			
			
			if (!($direction == 'in' && $view == 'list'))
			{
				if ($num_out)
				{
					$template->assign_block_vars('switch_messages_out', array(
						'start' => $start,
						'view' => $view,
					));
					
					if ($num_out == $start) $start = $start - $results_per_page;
					$stored_msgs = get_moderated_messages($start, $results_per_page, 'out');
		
					foreach ($stored_msgs as $message)
					{
						display_moderated_message($message, 'out');
					}
					
					$template->assign_block_vars('switch_messages_out.switch_yes_messages', array());
				}
				else
				{
					$template->assign_block_vars('switch_messages_out', array());
					$template->assign_block_vars('switch_messages_out.switch_no_messages', array());
				}
		
				if ($num_out > $results_per_page) 
				{
					if ($view == 'summary')
					{
						$template->assign_block_vars('switch_more_out', array(
							'more' => '<a href="' . append_sid('admin_m2f.php?mode=moderate&direction=out&view=list') . '">view all (' . $num_out . ')</a>', 
						));
					}
					else
					{
						$pagination = generate_pagination("admin_m2f.$phpEx?mode=moderate&direction=out&view=list", $num_out, $results_per_page, $start);
						$template->assign_block_vars('switch_messages_out.switch_pagination', array(
							'pagination' => $pagination, 
						));
					}
				}
			}			
		}
		
		break;
		

  // ---------------------------------------------------------------------------------

	case 'settings':
  default:

    if (isset($_POST['save_settings']))
    {
      save_m2f_settings();
      $message = 'Your Mail 2 Forum settings have been saved.' . "<br /><br />" . sprintf('Click %shere%s to return to Mail 2 Forum Settings' , "<a href=\"" . append_sid("admin_m2f.$phpEx?mode=settings") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");
	  	message_die(GENERAL_MESSAGE, $message);
    }

    if (isset($_POST['test_sendmail']))
    {
      save_m2f_settings();
			$template->assign_block_vars('switch_alert', array('header' => 'Sendmail path', 'message' => test_sendmail() ? '<span style="color: green">Sendmail path OK</p>' : '<span style="color: red">ERROR: Sendmail not found at ' . $_POST['_M2F_SENDMAIL_PATH_'] . '</p>'));
    }
    
    $template->set_filenames(array(
    		'body' => 'admin/m2f_settings.tpl')
    );    
    
    $template->assign_vars(get_m2f_settings());
    
  break;
  
}

///////////////////////////////////////////////////////////////////////////////////////


// SID constant
$template->assign_vars(array('S_M2F_ACTION' => append_sid('admin_m2f.' . $phpEx)));

// Output the template
$template->pparse('body');

include('page_footer_admin.'.$phpEx);

?>